package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class BigDataSort {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		String fileName = "bigdata.txt";
		int amount = 1000;
		int upLimit = (int) 10000;
		writeHugeAmoutInt(fileName, amount, upLimit);
		Set<Integer> intSet = readHugeAmoutInt(fileName);
		Integer[] result = null;
		result = intSet.toArray(new Integer[0]);
		System.out.println("done!");
	}

	public static Set<Integer> readHugeAmoutInt(String fileName) {
		Scanner in = null;
		Set<Integer> intSet = new HashSet<Integer>();
		try {
			in = new Scanner(new File(fileName));
			while (in.hasNextLine()) {
				intSet.add(Integer.parseInt(in.nextLine()));
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} finally {
			in.close();
		}
		System.out.println("amout is " + intSet.size());
		return intSet;
	}

	public static Set<Integer> readHugeAmoutIntUsingBufferReader(String fileName) {
		BufferedReader in = null;
		String line = null;
		Set<Integer> intSet = new HashSet<Integer>();
		try {

			in = new BufferedReader(new FileReader(fileName));
			while ((line = in.readLine()) != null) {
				intSet.add(Integer.parseInt(line));//add操作耗费了大量的时间，如果针对BitSort进行优化可以在读入的时候就对BitSet进行置位，可大大提高速度，但是通用性就不好
			}

		} catch (Exception e) {
			e.printStackTrace();

		} finally {
			try {
				in.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		System.out.println("amout is " + intSet.size());
		return intSet;
	}

	public static void writeHugeAmoutInt(String fileName, int amount,
			int upLimit) {
		PrintWriter out = null;
		try {
			out = new PrintWriter(fileName);
			for (int i = 0; i < amount; i++) {
				out.println(getRandomNumber(upLimit));
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			out.close();
		}
	}

	public static int getRandomNumber(int upLimit) {
		return (int) (Math.random() * upLimit);
	}
	
	public static void bitSetSort(Integer[] source,int upLimit){
		BitSet bs = new BitSet(upLimit);
		for (Integer e : source) {
			bs.set(e);
		}
		for (int i = 0,j = 0; i < upLimit; i++) {
			if (bs.get(i)){
				source[j++] = i;
			}
		}
	}

}
